#pragma once

#include <Textur.h>

#include "Block.h"
#include "BlockType.h"
#include "Item.h"

class BlockType;
class ItemType;
class DirtBlockType;
class DirtBlockItemType;

class BasicBlock : public Block
{
public:
    BasicBlock( ItemType *zTool, Framework::Vec3<int> pos, Framework::Textur *t );

    friend DirtBlockType;
};

class DirtBlockType : public BlockType
{
    REGISTRABLE( DirtBlockType )

protected:
    virtual void loadSuperBlock( Block *zBlock, Framework::StreamReader *zReader ) override;
    virtual Block *createBlock( Framework::Vec3<int> position ) override;
    DirtBlockType();
};
REGISTER( DirtBlockType, BlockType )

class DirtBlockItemType : public BasicBlockItemType
{
    REGISTRABLE( DirtBlockItemType )

protected:
    DirtBlockItemType();

public:
    virtual Item *createItem() const override;
};
REGISTER( DirtBlockItemType, ItemType )
