#pragma once

#include <Reader.h>
#include <ReferenceCounter.h>
#include <Vec3.h>

#include "StaticRegistry.h"

class Block;

class BlockType : public virtual Framework::ReferenceCounter
{
private:
    const int id;

protected:
    BlockType( int id );

    virtual void loadSuperBlock( Block *zBlock, Framework::StreamReader *zReader );
    virtual Block *createBlock( Framework::Vec3<int> position ) = 0;

public:
    virtual Block *loadBlock( Framework::Vec3<int> position, Framework::StreamReader *zReader );

    int getId() const;
};