#pragma once

#include <Punkt.h>
#include <ReferenceCounter.h>
#include <Reader.h>

#include "Area.h"

class Block;

class Chunk : public virtual Framework::ReferenceCounter
{
private:
    int dimensionId;
    Framework::Punkt location;
    Block **blocks;
    Chunk *zNeighbours[ 4 ];

public:
    Chunk( Framework::Punkt location, int dimensionId );
    Chunk( Framework::Punkt location, int dimensionId, Framework::StreamReader *zReader );
    ~Chunk();
    bool updateVisibility();
    Block *getBlockAt( Framework::Vec3<int> cLocation ) const;
    Block *zBlockAt( Framework::Vec3<int> cLocation ) const;
    void putBlockAt( Framework::Vec3<int> location, Block *block );
    void setNeighbor( Direction dir, Chunk *zChunk );
    void load( Framework::StreamReader *zReader );
    int getDimensionId() const;
    Framework::Punkt getCenter() const;
    Framework::Vec3<int> getMin() const;
    Framework::Vec3<int> getMax() const;
};