#pragma once

#include <Array.h>
#include <Trie.h>

#include "Chunk.h"
#include "Entity.h"

class Dimension : public virtual Framework::ReferenceCounter
{
private:
    int dimensionId;
    Framework::Trie<Chunk> *chunks;
    Framework::RCArray<Entity> *entities;
    void getAddrOf( Framework::Punkt cPos, char *addr ) const;
    void getAddrOfWorld( Framework::Punkt wPos, char *addr ) const;

public:
    Dimension( int id );
    ~Dimension();

    void updateVisibility();
    Block *zBlock( Framework::Vec3<int> location );
    void addEntity( Entity *entity );
    void addChunk( Chunk *chunk );
    int getDimensionId() const;
    bool hasChunck( int x, int y ) const;
    Chunk *zChunk( Framework::Punkt wPos ) const;
};