#define variable
#include <Text.h>
#include "Globals.h"
#include "Login.h"
#include "DirectConnect.h"
#include "Game.h"


void initVariables()
{
    dlls = new DLLRegister();
    menuRegister = new HashMap<Framework::Text, Framework::RCPointer<Menu>>( 10, []( Text txt )
    {
        return txt.hashCode();
    } );
    fontRegister = new HashMap<Framework::Text, Framework::RCPointer<Schrift>>( 10, []( Text txt )
    {
        return txt.hashCode();
    } );
    network = new NetworkHandler();
    currentGame = 0;
}

void initMenus()
{
    menuRegister->put( "login", RCPointer<Menu>::of( new LoginMenu( uiFactory.initParam.bildschirm ) ) );
    menuRegister->put( "directConnect", RCPointer<Menu>::of( new DirectConnect( uiFactory.initParam.bildschirm ) ) );
    menuRegister->put( "game", RCPointer<Menu>::of( new Game( uiFactory.initParam.bildschirm ) ) );

    menuRegister->get( "login" )->show();
}

void releaseVariables()
{
    if( currentGame )
        currentGame->release();
    menuRegister->release();
    fontRegister->release();
    network->release();
    dlls->release();
}